#ifdef OPENGL_ES
#extension GL_OES_standard_derivatives : enable
#ifdef GL_FRAGMENT_PRECISION_HIGH
precision highp float;
#else
precision mediump float;
#endif
#else
precision mediump float;
#endif

///////////////////////////////////////////////////////////
// Uniforms
uniform float u_time;
uniform vec3 u_resolution;	// ӁIdlIvec2Ȃ̂vec3őp
///////////////////////////////////////////////////////////
// Varyings
varying vec2 v_texCoord;

void main()
{
	// oߎԂɂF̕ω
	float t = u_time * 1.5;
	float r = sin(t);
	float g = cos(t);
	float b = atan(r, g);

	// XLC
	float s = sin(v_texCoord.y *  500.0 * 3.1415 + u_time * 3.0);
	s = mix(1.0, (s + 1.0), 1.0);

	// ͂Â
	vec2 m = v_texCoord * 2.0 - 1.0;
	vec2 o = abs(m.yx) / vec2(6.0, 4.0);
	m += m * o * o;
	m = abs(m);
	m.x = pow(m.x, 15.0);
	m.y = pow(m.y, 15.0);
	r = mix(abs(r), 0.0, m.x + m.y);
	g = mix(abs(g), 0.0, m.x + m.y);
	b = mix(abs(b), 0.0, m.x + m.y);

	gl_FragColor = vec4(r * s, g * s, b * s, 1.0);
}
